SystemOrganization addCategory: #'Khami-Test-Core'!
SystemOrganization addCategory: #'Khami-Test-Core-Support'!
SystemOrganization addCategory: #'Khami-Test-Web'!

TestCase subclass: #KmDirectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
testOppositeBottom
	self assert: Top equals: Bottom opposite! !

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
testOppositeLeft
	self assert: Right equals: Left opposite! !

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
testOppositeRight
	self assert: Left equals: Right opposite! !

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:16'!
testOppositeTop
	self assert: Bottom equals: Top opposite! !

TestCase subclass: #KmGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 20:17'!
testCurrentTileStartsBlank
	 | game |
	game := KmGame testGame.
	self assert: nil equals: game currentTile.! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 13:26'!
testPlaceTile
	| game gameBoard tile | 
	game := KmGame testGame.
	gameBoard := game board.
	tile := game takeTile.
	game placeTileAt: 3 at: 2.
	self assert: tile equals: (gameBoard at: 3 at: 2)! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:50'!
testPlaceTileClearsCurrentTile
	| game gameBoard tile | 
	game := KmGame testGame.
	gameBoard := game board.
	tile := game takeTile.
	game placeTileAt: 1 at: 2.
	self assert: nil equals: game currentTile! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2011 00:34'!
testPlaceTileWontReplaceExistingTile
	| game gameBoard tile | 
	game := KmGame testGame.
	gameBoard := game board.
	tile := game takeTile.
	game placeTileAt: 3 at: 2.
	game placeTileAt: 3 at: 2.
	self assert: tile equals: (gameBoard at: 3 at:2)
! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 17:05'!
testTakeTile
	| game tile |
	game := KmGame testGame.
	tile := game remainingTiles last.
	self assert: tile equals: game takeTile! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 16:57'!
testTakeTileRemovesItFromRemaining
	| game tile |
	game := KmGame testGame.
	tile := game takeTile.
	self deny: (game remainingTiles includes: tile).! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 20:19'!
testTakeTileSetsCurrentTile
	| game tile |
	game := KmGame testGame.
	tile := game takeTile.
	self assert: tile equals: game currentTile.! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/21/2011 13:26'!
testTakeTileTwiceDoesntTakeAdditionalTile
	| game tile |
	game := KmGame testGame.
	tile := game takeTile.
	self assert: tile equals: game takeTile! !

TestCase subclass: #KmTerritoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 21:18'!
testCompleteVillage
	| tile1 tile2 |
	tile1 := KmTile fromString: 'VFFFVFFFF'.
	tile2 := KmTile fromString: 'FFVFFFVFF'.
	tile1 tileAt: Top put: tile2.
	self assert: (tile1 at: Top) territory isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 22:07'!
testIsComplete
	| tile1 tile2 |
	tile1 := KmTile fromString: 'FFFF-FFFF'.
	tile2 := KmTile fromString: 'FFFFFF-FF'.
	tile1 tileAt: Top put: tile2.
	self assert: (tile1 at: Top) territory isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 21:20'!
testLoopContentsIsComplete
	| tileSet |
	tileSet := KmTile buildTileSet: {
		'FFFFFF---'. 'FFFFF--F-'. 'FFFF--FF-'. 'FFFF-FF--'.
	}..
	(tileSet at: 1) tileAt: Left put: (tileSet at: 2).
	(tileSet at: 2) tileAt: Bottom put: (tileSet at: 3).
	(tileSet at: 3) tileAt: Right put: (tileSet at: 4).
	(tileSet at: 4) tileAt: Top put: (tileSet at: 1).
	
	self assert: ((tileSet at: 1) at: LeftBottom) territory isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 21:20'!
testLoopContentsSegmentIsComplete
	| tileSet |
	tileSet := KmTile buildTileSet: {
		'FFFFFF---'. 'FFFFF--F-'. 'FFFF--FF-'. 'FFFF-FF--'.
	}..
	(tileSet at: 1) tileAt: Left put: (tileSet at: 2).
	(tileSet at: 2) tileAt: Bottom put: (tileSet at: 3).
	(tileSet at: 3) tileAt: Right put: (tileSet at: 4).
	(tileSet at: 4) tileAt: Top put: (tileSet at: 1).
	
	self assert: ((tileSet at: 1) at: LeftBottom) isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 21:20'!
testLoopIsComplete
	| tileSet |
	tileSet := KmTile buildTileSet: {
		'FFFFFF---'. 'FFFFF--F-'. 'FFFF--FF-'. 'FFFF-FF--'.
	}..
	(tileSet at: 1) tileAt: Left put: (tileSet at: 2).
	(tileSet at: 2) tileAt: Bottom put: (tileSet at: 3).
	(tileSet at: 3) tileAt: Right put: (tileSet at: 4).
	(tileSet at: 4) tileAt: Top put: (tileSet at: 1).
	
	self assert: ((tileSet at: 1) at: Left) territory isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 21:20'!
testLoopSegmentIsComplete
	| tileSet |
	tileSet := KmTile buildTileSet: {
		'FFFFFF---'. 'FFFFF--F-'. 'FFFF--FF-'. 'FFFF-FF--'.
	}..
	(tileSet at: 1) tileAt: Left put: (tileSet at: 2).
	(tileSet at: 2) tileAt: Bottom put: (tileSet at: 3).
	(tileSet at: 3) tileAt: Right put: (tileSet at: 4).
	(tileSet at: 4) tileAt: Top put: (tileSet at: 1).
	
	self assert: ((tileSet at: 1) at: Left) isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:54'!
testMergeWith
	| s1 s2 |
	s1 := KmFarmRegion in: nil.
	s2 := KmFarmRegion in: nil.
	s1 territory mergeWith: s2 territory.
	self assert: s2 territory equals: s1 territory! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:55'!
testMergeWithAddsSegments
	| s1 s2 |
	s1 := KmFarmRegion in: nil.
	s2 := KmFarmRegion in: nil.
	s1 territory mergeWith: s2 territory.
	self assert: 2 equals: s1 territory size.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:55'!
testMergeWithRemovesAllSegments
	| s1 s2  territory |
	s1 := KmFarmRegion in: nil.
	territory := s1 territory.
	s2 := KmFarmRegion in: nil.
	s1 territory mergeWith: s2 territory.
	self assert: territory isEmpty! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 21:17'!
testNotComplete
	| tile1 tile2 |
	tile1 := KmTile fromString: 'FFFF-FFFF'.
	tile2 := KmTile fromString: 'FFFF-F-F-'.
	tile1 tileAt: Top put: tile2.
	self deny: (tile1 at: Top) territory isComplete.! !

!KmTerritoryTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testTilesInSingleTile
	| tile |
	tile := KmTile blank.
	self assert: 1 equals: tile territories any tiles size.! !

TestCase subclass: #KmTestGameBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testCanPlaceTile
	| board |
	board := KmGameBoard new.
	self assert: (board canPlaceTile: KmTile blank at: 3 at: 2) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testCantPlaceTileBecauseAlreadyOccupied
	| board |
	board := KmGameBoard new.
	self deny: (board canPlaceTile: KmTile blank at: 2 at: 2) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testCantPlaceTileBecauseDoesntConnect
	| board |
	board := KmGameBoard new.
	self deny: (board canPlaceTile: KmTile blank at: 1 at: 2) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testCantPlaceTileBecauseNotAvailable
	| board |
	board := KmGameBoard new.
	self deny: (board canPlaceTile: KmTile blank at: 1 at: 1) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:33'!
testInitialColumnsIs3
	self assert: 3 equals: KmGameBoard new columns.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:34'!
testInitialRowsIs3
	self assert: 3 equals: KmGameBoard new rows.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTile
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 3 at: 2 put: tile.
	self assert: tile equals: (gameBoard at: 3 at: 2)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileAtBottomEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 3 at: 2 put: tile.
	self assert: 4 equals: gameBoard rows.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileAtLeftEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 2 at: 1 put: tile.
	self assert: 4 equals: gameBoard columns.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileAtLeftEdgeExtendsBoardAndRelocates
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 2 at: 1 put: tile.
	self assert: tile equals: (gameBoard at: 2 at: 2)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileAtRightEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 3 at: 1 put: tile.
	self assert: 4 equals: gameBoard columns.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileAtTopEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 1 at: 2 put: tile.
	self assert: 4 equals: gameBoard rows.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileAtTopEdgeExtendsBoardAndRelocates
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 1 at: 2 put: tile.
	self assert: tile equals: (gameBoard at: 2 at: 2)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 22:31'!
testPlaceTileConnectsItToItsNeighbour
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile blank.
	gameBoard at: 3 at: 2 put: tile.
	self assert: tile equals: ((gameBoard at: 2 at: 2) tileAt: Bottom)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:47'!
testStartingTileAtCentre
	| board |
	board := KmGameBoard new.
	self assert: board startingTile equals: (board at: 2 at: 2)! !

TestCase subclass: #KmTestGrid
	instanceVariableNames: 'fiveBySeven'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core-Support'!

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2011 12:42'!
setUp
	fiveBySeven := KmGrid ofSize: 5 by: 7.
	1 to: 5 do: [ :row |
		1 to: 7 do: [ : column | fiveBySeven at: row at: column put: row displayString, 'x', column displayString]] ! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:22'!
testAddColumn
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid addColumn.
	self assert: 8 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testAddColumns
	| grid |
	grid := KmGrid new.
	grid addColumns: 7.
	self assert: 7 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:21'!
testAddRow
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid addRow.
	self assert: 6 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testAddRows
	| grid |
	grid := KmGrid new.
	grid addRows: 5.
	self assert: 5 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 19:57'!
testAdjacentItems
	self assert: ({'1x2'. '2x3'. '3x2'. '2x1' } hasEqualElements: (fiveBySeven adjacentItemsAt: 2 at: 2))! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testEmptyGridColumns
	self assert: 0 equals: KmGrid new columns ! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testEmptyGridRows
	self assert: 0 equals: KmGrid new rows! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testInitialDataIsNil
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	self assert: nil equals: (grid at: 3 at: 4)! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testInitialSizeColumns
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	self assert: 7 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testInitialSizeRows
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	self assert: 5 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:17'!
testPrependColumn
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid prependColumn.
	self assert: 8 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:14'!
testPrependColumnMovesItems
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid at: 2 at: 2 put: 'foo'.
	grid prependColumn.
	self assert: nil equals: (grid at: 2 at: 2).
	self assert: 'foo' equals: (grid at: 2 at: 3).! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:16'!
testPrependRow
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid prependRow.
	self assert: 6 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:16'!
testPrependRowMovesItems
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid at: 2 at: 2 put: 'foo'.
	grid prependRow.
	self assert: nil equals: (grid at: 2 at: 2).
	self assert: 'foo' equals: (grid at: 3 at: 2).! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testPutAndRetrieve
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid at: 3 at: 4 put: 'foo'.
	self assert: 'foo' equals: (grid at: 3 at: 4)! !

TestCase subclass: #KmTileSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 23:11'!
testBlockerIsIncomplete
	self deny: (KmBlocker in: nil) isComplete.! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 21:56'!
testCompletingTerritoryCompletesSegment
	| tile1 tile2 |
	tile1 := KmTile fromString: 'FFFF-FFFF'.
	tile2 := KmTile fromString: 'FFFFFF-FF'.
	tile1 tileAt: Top put: tile2.
	self assert: (tile1 at: Top) isComplete.! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 16:19'!
testFarmRegionFromCode
	self assert: (KmTileSegment fromChar: $F in: nil) isFarm! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 21:56'!
testInitialSegmentIsIncomplete
	self deny: (KmRoadPath in: nil) isComplete.! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 23:11'!
testNewSegmentIsIncomplete
	self deny: (KmFarmRegion in: nil) isComplete.! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 16:12'!
testPlacementInTileSetsTileAndLocation
	| tile |
	! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:52'!
testRoadConnectsToRoad
	self assert: ((KmRoadPath in: nil) connectsTo:  (KmRoadPath in: nil))! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 22:57'!
testRoadDoesntConnectToBlocker
	self deny: ((KmRoadPath in: nil) connectsTo:  (KmBlocker in: nil))! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 16:19'!
testRoadPathFromCode
	self assert: (KmTileSegment fromChar: $- in: nil) isRoad! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:52'!
testRoadisPath
	self assert: (KmRoadPath in: nil) isPath.! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 22:21'!
testSegmentLocationAfterRotation
	| tile segment |
	tile := KmTile fromString: 'VFFFFFFFF'.
	segment := tile at: Top.
	tile rotate.
	self assert: Right equals: segment location.! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 16:19'!
testUnknownCodeThrowsError
	self should: [ KmTileSegment fromChar: $z in: nil ] raise: Error! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:53'!
testVillageConnectsToVillage
	self assert: ((KmVillageRegion in: nil) connectsTo:  (KmVillageRegion in: nil))! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 22:58'!
testVillageConnectsToWall
	self assert: ((KmVillageRegion in: nil) connectsTo:  (KmVillageWall in: nil))! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 17:53'!
testVillageDoesntConnectToFarm
	self deny: ((KmVillageRegion in: nil) connectsTo:  (KmFarmRegion in: nil))! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 16:19'!
testVillageRegionFromCode
	self assert: (KmTileSegment fromChar: $V in: nil) isVillage! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 22:59'!
testWallConnectsToVillage
	self assert: ((KmVillageWall in: nil) connectsTo:  (KmVillageRegion in: nil))! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 23:03'!
testWallDoesntConnectToFarm
	self deny: ((KmVillageWall in: nil) connectsTo:  (KmFarmRegion in: nil))! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 22:59'!
testWallDoesntConnectToWall
	self deny: ((KmVillageWall in: nil) connectsTo:  (KmVillageWall in: nil))! !

TestCase subclass: #KmTileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:33'!
assertMappings: aCollection for: aTile
	self assert: (aCollection allSatisfy: [ :assoc | self verify: assoc key isNumber: assoc value inTile: aTile ]).! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/31/2011 22:56'!
testAdjacentVillagesInDifferentTerritories
	| tile |
	tile := KmTile fromString: 'WWFFVVFFF'.
	self deny: (tile at: Top) territory = (tile at: Right) territory.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testAllowsTile
	| tile1 |
	tile1 := KmTile startingTile.
	self assert: (tile1 allowsTile: KmTile blank at: Bottom)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testAllowsTileReturnsFalse
	| tile1 |
	tile1 := KmTile startingTile.
	self deny: (tile1 allowsTile: KmTile blank at: Top)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testAllowsTileReturnsFalseDueToPaths
	| tile1 |
	tile1 := KmTile startingTile.
	self deny: (tile1 allowsTile: KmTile blank at: Right)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testAllowsTileReturnsFalseWhenAlreadyOccupied
	| tile1 |
	tile1 := KmTile startingTile.
	tile1 tileAt: Bottom put: KmTile blank.
	self deny: (tile1 allowsTile: KmTile blank at: Bottom)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2011 12:14'!
testAlongPathDo
	| tile1 tile2 region |
	tile1 := KmTile startingTile.
	tile1 alongPathAt: Left do: [ :t : r | 
		tile2 isNil ifTrue: [ tile2 := t] ifFalse: [ self fail].
		region isNil ifTrue: [region := r] ifFalse: [self fail]].
	self assert: tile1 equals: tile2.
	self assert: Left equals: region.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2011 12:21'!
testAlongPathDoVisitsCorrectNumberOfSegments
	| tile1 count |
	count := 0.
	tile1 := KmTile startingTile.
	tile1 tileAt: Left put: (KmTile fromString: 'FFFFF--F-').
	tile1 alongPathAt: Left do: [ :t : r | count := count + 1].
	self assert: 4 equals: count..! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testAlongPathDoWithNoPathDoesNothing
	| tile1 tile2 region |
	tile1 := KmTile blank.
	tile1 alongPathAt: Left do: [ :t : r |  self fail].
	self assert: true.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2011 13:10'!
testAlongPathDoWontLoopForever
	| tileSet count |
	tileSet := KmTile buildTileSet: {
		'FFFFFF---'. 'FFFFF--F-'. 'FFFF--FF-'. 'FFFF-FF--'.
	}..
	(tileSet at: 1) tileAt: Left put: (tileSet at: 2).
	(tileSet at: 2) tileAt: Bottom put: (tileSet at: 3).
	(tileSet at: 3) tileAt: Right put: (tileSet at: 4).
	(tileSet at: 4) tileAt: Top put: (tileSet at: 1).

	count := 0.
	(tileSet at: 1) alongPathAt: Left do: [ :t : r | count := count + 1.
		(count > 12) ifTrue: [ self fail]].
	self assert: 12 equals: count.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:48'!
testBuildFromString
	| tile |
	tile := KmTile fromString: 'VFVFF-F--'.
	self assert: (tile at: TopLeft) isVillage.
	self assert: (tile at: TopRight) isVillage.
	self assert: (tile at: RightTop) isFarm.
	self assert: (tile at: RightBottom) isFarm.
	self assert: (tile at: BottomRight) isVillage.
	self assert: (tile at: BottomLeft) isVillage.
	self assert: (tile at: LeftBottom) isFarm.
	self assert: (tile at: LeftTop) isFarm.

	self assert: (tile at: Top) isFarm. 
	self assert: (tile at: Left) isRoad.
	self assert: (tile at: Bottom) isFarm.
	self assert: (tile at: Right) isRoad.
	self assert: (tile at: Centre) isRoad.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:50'!
testBuildTileSet
	| set |
	set := KmTile buildTileSet: {
		'FFFFFFFFF'.
		'FFFFFFFFF'.
		'FFFFFFFFF'.
	}.
	self assert: 3 equals: set size.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testCantCollectNonExistentPath
	| tile |
	tile := KmTile blank.
	self  assert: 0 equals: (tile collectPathAt: Top) size.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2011 20:50'!
testCollectCompletePathWithTwoTiles
	| tile1 tile2 path |
	tile1 := KmTile startingTile.
	tile2 := KmTile fromString: 'FFFFF-FFF'.
	tile1 tileAt: Left put: tile2.
	path := (tile1 collectPathAt: Left) .
	self assert: 2 equals: path size.
	self assert: tile2 equals: path last! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/26/2011 15:39'!
testCollectPath
	| tile |
	tile := KmTile startingTile.
	self assert: 1 equals: (tile collectPathAt: Left) size.
	self assert: ((tile collectPathAt: Left) includes: tile).! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 18:32'!
testComplexTerritories
	| tile1 |
	tile1 := KmTile fromString: 'VFFFV-F--'.
	self assert: 4 equals: tile1 territories size! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 18:23'!
testCrossroadTerritories
	| tile1 |
	tile1 := KmTile fromString: 'FFFF----.'.
	self assert: 8 equals: tile1 territories size.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 19:03'!
testInitialPaths
	| tile |
	tile := KmTile blank.
	self assertMappings: {
		Top -> 2.
		Right -> 5.
		Bottom -> 8.
		Left -> 11.
		Centre ->13 } for: tile.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 19:03'!
testInitialRegions
	| tile |
	tile := KmTile blank.
	self assertMappings: {
		TopLeft -> 1. TopRight -> 3.
		RightTop -> 4. RightBottom -> 6.
		BottomRight -> 7. BottomLeft ->9.
		LeftBottom -> 10. LeftTop -> 12} for: tile.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testNewTileHasNothingAdjacent
	 | tile |
	tile := KmTile blank.
	self assert: nil equals: (tile tileAt: Top).
	self assert: nil equals: (tile tileAt: Right).
	self assert: nil equals: (tile tileAt: Bottom).
	self assert: nil equals: (tile tileAt: Left)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTile
	 | t1 t2 |
	t1 := KmTile blank.
	t2 := KmTile blank.
	
	t1 tileAt: Top put: t2.
	self assert: t2 equals: (t1 tileAt: Top)
! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2011 19:03'!
testPlaceTileSetsReciprocalTile
	 | t1 t2 |
	t1 := KmTile blank.
	t2 := KmTile blank.
	
	t1 tileAt: Top put: t2.
	self assert: t1 equals: (t2 tileAt: Bottom)
! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 20:49'!
testPlacingTileMergesTeritories
	| tile1 tile2 |
	tile1 := KmTile blank.
	tile2 := KmTile blank.
	tile1 tileAt: Left put: tile2.
	self assert: tile1 territories equals: tile2 territories! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 19:03'!
testRotatedPaths
	| tile |
	tile := KmTile blank.
	tile rotate.
	self assertMappings: {
		Top -> 11.
		Right -> 2.
		Bottom -> 5.
		Left -> 8.
		Centre ->13 } for: tile.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 19:03'!
testRotatedRegions
	| tile |
	tile := KmTile blank.
	tile rotate.
	self assertMappings: {
		TopLeft -> 10. TopRight -> 12.
		RightTop -> 1. RightBottom -> 3.
		BottomRight -> 4. BottomLeft ->6.
		LeftBottom -> 7. LeftTop -> 9} for: tile.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/30/2011 19:23'!
testSimpleTerritories
	| tile1 |
	tile1 := KmTile blank.
	self assert: 1 equals: tile1 territories size.! !

!KmTileTest methodsFor: 'convenience' stamp: 'StuartHerring 1/28/2011 20:34'!
verify: aSymbol isNumber: aNumber inTile: aTile
	^((aTile instVarNamed: #regions) at: aNumber) = (aTile at: aSymbol)! !
